#ifndef __WINE_MIXEDCRT_IO_H
#define __WINE_MIXEDCRT_IO_H

/*
 * Embrace
 */

#ifdef __GNUC__
#include_next <unistd.h>
#else
#include "nativecrt/unistd.h"
#endif



/*
 * Extend
 */

#define _O_RDONLY                  O_RDONLY
#define _O_WRONLY                  O_WRONLY
#define _O_RDWR                    O_RDWR
#define _O_APPEND                  O_APPEND
#define _O_CREAT                   O_CREAT
#define _O_TRUNC                   O_TRUNC
#define _O_EXCL                    O_EXCL

#define _O_TEXT                    0x4000
#define _O_BINARY                  0x8000

#define _access(pathname,mode)     access(pathname,mode)
#define _chmod(pathname,mode)      chmod(pathname,mode)
#define _chsize(fd,length)         ftruncate(fd,length)
#define _close(fd)                 close(fd)
#define _commit(fd)                fsync(fd)
#define _creat(pathname,mode)      create(pathname,mode)
#define _dup(fd)                   dup(fd)
#define _dup2(oldfd,newfd)         dup2(oldfd,newfd)
#define _eof(fd)                   eof(fd)
#define _filelength(fd)            ({struct stat s_;fstat(fd,&s_);s_.st_size;})
#define filelength(fd)             _filelength(fd)
/* _findfirst */
/* _findnext */
/* _findclose */
#define _isatty(fd)                isatty(fd)
#define _locking(fd,cmd,len)       lockf(fd,cmd,len)
#define _locking(fd,cmd,len)       locking(fd,cmd,len)
#define _lseek(fd,offset,whence)   lseek(fd,offset,whence)
#define _mktemp(template)          mktemp(template)
#define _open                      open
#define _pipe(filedes)             pipe(filedes)
#define _read(fd,buf,len)          read(fd,buf,len)
#define _setmode(fd,mode)          (O_BINARY)
#define setmode(fd,mode)           _setmode(fd,mode)
/* _sopen */
/* sopen */
#define _tell(fd)                  lseek(fd,0,SEEK_CUR)
#define _umask(mask)               umask(mask)
#ifndef _unlink
#define _unlink(pathname)          unlink(pathname)
#endif
#define _write(fd,buf,len)         write(fd,buf,len)
/* _filelengthi64 */
/* _findfirsti64 */
/* _findnexti64 */
/* _lseeki64 */
/* _telli64 */

/* _waccess */
/* _wchmod */
/* _wcreat */
/* _wfindfirst */
/* _wfindnext */
/* _wunlink */
/* _wrename */
/* _wopen */
/* _wsopen */
/* _wmktemp */
/* _wfindfirsti64 */
/* _wfindnexti64 */

/* _get_osfhandle */
#define _open_osfhandle(hf,mode)   CRTDLL__open_osfhandle(hf,mode)


#endif /* __WINE_MIXEDCRT_IO_H */
