#ifndef __WINE_MIXEDCRT_STDLIB_H
#define __WINE_MIXEDCRT_STDLIB_H

/*
 * Embrace
 */

#include <unistd.h>
#ifdef __GNUC__
#include_next <stdlib.h>
#else
#include "nativecrt/stdlib.h"
#endif



/*
 * Extend
 */

#define _errno                     errno
#define __doserrno()               &errno
#define _doserrno                  errno
/* __argc */
/* __argv */
#define _environ                   __environ
#define environ                    __environ
#define _fmode                     O_BINARY

#define _atoi64(str)               strtoq(str,NULL,10)
#define _atold(str)                strtold(str,NULL)
#define _itoa(x,buf,rdx)           (((rdx)==8?sprintf(buf,"%o",(int)x):(rdx)==16?sprintf(buf,"%x",(int)x):sprintf(buf,"%d",(int)x)),buf)
#define itoa(x,buf,rdx)            _itoa(x,buf,rdx)
#define _i64toa(x,buf,rdx)         (((rdx)==8?sprintf(buf,"%llo",(long long int)x):(rdx)==16?sprintf(buf,"%llx",(long long int)x):sprintf(buf,"%lld",(long long int)x)),buf)
#define _ltoa(x,buf,rdx)           (((rdx)==8?sprintf(buf,"%lo",(long int)x):(rdx)==16?sprintf(buf,"%lx",(long int)x):sprintf(buf,"%ld",(long int)x)),buf)
#define ltoa(x,buf,rdx)            _ltoa(x,buf,rdx)
/* _mbstrlen */
/* _set_error_mode */
#define _ui64toa(x,buf,rdx)        (((rdx)==8?sprintf(buf,"%llo",(long long unsigned int)x):(rdx)==16?sprintf(buf,"%llx",(long long unsigned int)x):sprintf(buf,"%llu",(long long unsigned int)x)),buf)
#define _ultoa(x,buf,rdx)          (((rdx)==8?sprintf(buf,"%lo",(long unsigned int)x):(rdx)==16?sprintf(buf,"%lx",(long unsigned int)x):sprintf(buf,"%lu",(long unsigned int)x)),buf)
#define ultoa(x,buf,rdx)           _ultoa(x,buf,rdx)

/* _itow */
/* _ltow */
/* _ultow */
/* _ultow */
/* wcstod */
/* wcstol */
/* wcstoul */
/* _wgetenv */
/* _wsystem */
/* _wtoi */
/* _wtol */
/* _i64tow */
/* _ui64tow */
/* _wtoi64 */

#define _ecvt(nb,dgt,dec,sgn)      ecvt(nb,dgt,dec,sgn)
#define _exit(code)                exit(code)
#define _fcvt(nb,dgt,dec,sgn)      fcvt(nb,dgt,dec,sgn)
#define _fullpath(ap,rp,len)       CRTDLL__fullpath(ap,rp,len)
#define _gcvt(nb,dgt,buf)          gcvt(nb,dgt,buf)
/* _lrotl */
/* _lrotr */
#define _makepath(p,dr,d,f,e)      CRTDLL__makepath(p,dr,d,f,e)
/* _onexit */
#define _putenv(string)            putenv(string)
/* _rotl */
/* _rotr */
/* _searchenv */
#define _splitpath(p,dr,d,f,e)     CRTDLL__splitpath(p,dr,d,f,e)
#define _swab(from,to,n)           swab(from,to,n)

/* _wfullpath */
/* _wmakepath */
/* _wperror */
/* _wputenv */
/* _wsearchenv */
/* _wsplitpath */


#endif /* __WINE_MIXEDCRT_STDLIB_H */
